// JavaScript Document

var xhr = vytvorXHR(); 

var pole=[0];
var pocet_cyklu=0;

// pomocne hodnoty pro zachovani zoomu a souradnic
var souradnice= new GLatLng(50.009075, 15.396396);
var zoom= 7;

var map;
var UIC;
var TRAIN_NUMBER;
var LATITUDE;
var LONGITUDE;
var DATUM;
var SPEED;
var AZIMUT;
var markerCluster=null;
// Funkce pro AJAX
function vytvorXHR(){  
    var xhr;
    try{
        xhr = new XMLHttpRequest();
    }catch(e){
        var MSXmlVerze = new Array('MSXML2.XMLHttp.6.0','MSXML2.XMLHttp.5.0','MSXML2.XMLHttp.4.0','MSXML2.XMLHttp.3.0','MSXML2.XMLHttp.2.0','Microsoft.XMLHttp');
        for(var i = 0; i <= MSXmlVerze.length; i ++){
            try{  
                xhr = new ActiveXObject(MSXmlVerze[i]);
                alert(MSXmlVerze[i]);
                break;
            }catch(e){
            
            }
        }
    }
    if(!xhr)
        alert("Dolo k chyb pi vytven objektu XMLHttpRequest!");
    else
         
        return xhr;
}  
     
// Funkce pro Ajax
function prectiSoubor(){  
    try{
        xhr.open("POST","PHP_skripty/D_mapa.php",true);
        xhr.onreadystatechange = ctiOdpoved;
        xhr.send(null);
    }catch(e){
        alert("Nelze se pipojit k serveru:\n" + e.toString());
    }
}  	


function ctiOdpoved(){
    if(xhr.readyState == 4){
        if(xhr.status == 200){
            try{
                var XMLRes = xhr.responseXML;
                if(!XMLRes || !XMLRes.documentElement){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
       
                var rootNodeName = XMLRes.documentElement.nodeName;
                if(rootNodeName == "parsereerror"){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
          
     
                vykresliMapu();
                // naplneni pole dat
                xmlRoot = XMLRes.documentElement;
                UIC = xmlRoot.getElementsByTagName("UIC");
                TRAIN_NUMBER = xmlRoot.getElementsByTagName("TRAIN_NUMBER");
                LATITUDE = xmlRoot.getElementsByTagName("LATITUDE");
                LONGITUDE = xmlRoot.getElementsByTagName("LONGITUDE");
                DATUM = xmlRoot.getElementsByTagName("DATUM");
                SPEED = xmlRoot.getElementsByTagName("SPEED");
                AZIMUT = xmlRoot.getElementsByTagName("AZIMUT");
       
                naplnPole();

                vykresliVlaky();
                window.setInterval("vykresliVlaky()",2000);

            }catch(e){
                alert("Chyba pri cteni odpovedi:"+e.toString());
            }
        }else{
            alert("Pozadavek HTTP neni v poradku.")
        }
    }
}
// vyber aktualnich vzkreslovanych vlaku
function vykresliVlaky(){
    var sirka, delka, lokom, dat, c_vlak, spe, cesta,point;
    var cislo2=pocet_cyklu;
    var markers=[];
    markerCluster.clearMarkers();
    map.clearOverlays();
  
    for(var j=0;j<pole.length-1; j++){
        if(cislo2<TRAIN_NUMBER.length-1){
            if(pocet_cyklu<pole[j]){
                sirka=LATITUDE.item(cislo2).firstChild.data;
                delka=LONGITUDE.item(cislo2).firstChild.data;
                sirka/=100000;
                delka/=100000;
                lokom=UIC.item(cislo2).firstChild.data;
                dat=DATUM.item(cislo2).firstChild.data;
                spe=SPEED.item(cislo2).firstChild.data;
                c_vlak=TRAIN_NUMBER.item(cislo2).firstChild.data;
                point = new GLatLng(sirka,delka);
                markers.push(createMarker(point,cislo2,lokom,dat,spe,c_vlak))
            }
        }
        cislo2+=pole[j];
    }
    markerCluster= new MarkerClusterer(map,markers);
    pocet_cyklu+=1;
}
// naplneni pomocnych poli
function naplnPole(){
    var PTN=TRAIN_NUMBER.item(0).firstChild.data;
    var pocet=0;
    var i=0;

    while(i<TRAIN_NUMBER.length){

        if(PTN==TRAIN_NUMBER.item(i).firstChild.data){
            pocet+=1;
        }else{
            if(pole[0]==0){
                pole[0]=pocet;
            }else{
                pole.push(pocet);
            }
            pocet=1;
            PTN=TRAIN_NUMBER.item(i).firstChild.data;
        }
        i++;
    }
    if(pocet>1){
        pole.push(pocet);
    }
}
// vykresleni mapy
function vykresliMapu(){
    var souradnice= new GLatLng(50.009075, 15.396396);
    var zoom= 7;
    map = new GMap2(document.getElementById("map"));
    map.addControl(new GSmallMapControl());
    map.addControl(new GMapTypeControl());
    map.setCenter(souradnice,zoom);
    markerCluster = new MarkerClusterer(map);
}

// vytvoreni ikon a vytvoreni popisku
function createMarker(point, index,lokom,datum,speed,c_vlak) {
    // vytvoreni Ikony
    var ikona_vlak = new GIcon();
    ikona_vlak.image = "images/lokomotivy/471.gif";
    ikona_vlak.iconSize = new GSize(20, 20);
    ikona_vlak.iconAnchor = new GPoint(10, 10);
    ikona_vlak.infoWindowAnchor = new GPoint(10, 10);
                                  

    var txt="Cis. vlaku: "+c_vlak;
    markerOptions = {
        icon:ikona_vlak,
        title: txt
    };
    var marker = new GMarker(point, markerOptions);
    //zavreni ginfowindow
    GEvent.addListener(marker, "mouseout", function() {
        map.closeInfoWindow();
    });
    //otevreni ginfowindow
    var text="Vlak: "+c_vlak+" <br> Lokomotiva: "+lokom+"<br> Datum: "+datum+"<br> Rychlost: "+speed;
    GEvent.addListener(marker, "mouseover", function() {
        marker.openInfoWindowHtml(text);
    });
      
    return marker;
}

