
// Ajax
var xhr = vytvorXHR();
// Mapa
var map;
// pole pro nacitani z xml
var pole= new Array();
var dpole=new Array();
var bpole=new Array();

// cas startu odpocitavani
var cas=new Date(2010,2,15,21,0,0);
var vteriny=1000;
//nacteni XML

var UIC;
var TRAIN_NUMBER;
var LATITUDE;
var LONGITUDE;
var DATUM;
var SPEED;
var AZIMUT;


var markerCluster=null;
// Funkce pro AJAX
function vytvorXHR(){
    var xhr;
    try{
        xhr = new XMLHttpRequest();
    }catch(e){
        var MSXmlVerze = new Array('MSXML2.XMLHttp.6.0','MSXML2.XMLHttp.5.0','MSXML2.XMLHttp.4.0','MSXML2.XMLHttp.3.0','MSXML2.XMLHttp.2.0','Microsoft.XMLHttp');
        for(var i = 0; i <= MSXmlVerze.length; i ++){
            try{
                xhr = new ActiveXObject(MSXmlVerze[i]);
                alert(MSXmlVerze[i]);
                break;
            }catch(e){
            
            }
        }
    }
    if(!xhr)
        alert("Dolo k chyb pi vytven objektu XMLHttpRequest!");
    else
        return xhr;
}

//funkce pro zvetseni hodin
function hodiny(){
    var d,m,n,min,sec,r;
    var loc=cas.getTime();
    loc=loc+30000;
    cas=new Date(loc);
    with(cas){
        d = getDate();
        m = getMonth()+1;
        h = getHours();
        min = getMinutes();
        sec = getSeconds();
        if (document.all)
            r = getYear()
        else r = getYear() + 1900
        }
    var text=d+"."+m+"."+r+" "+h+":"+min+":"+sec;
    document.form1.den.value=text;
}

// porovna casi, jestli zaznam casu vlaku a aktualni cas souhalsi
function porovnej(pr){
   
    ret=/[- :]+/;
    var text=DATUM.item(pr).firstChild.data;
    d_pole=text.split(ret);
    var datum=new Date(d_pole[0],d_pole[1]-1,d_pole[2],d_pole[3],d_pole[4],d_pole[5]);
        
    if(datum.getTime()<cas.getTime()){
        return true;
    }
    else{
        return false;
    }
}

// Funkce pro Ajax
function prectiSoubor(){
    try{
        
        xhr.open("POST","PHP_skripty/D_mapa.php",true);
        xhr.onreadystatechange = ctiOdpoved;
        xhr.send(null);
    }
    catch(e){
        alert("Nelze se pipojit k serveru:\n" + e.toString());
    }
}

function ctiOdpoved(){
    if(xhr.readyState == 4){
        if(xhr.status == 200){
            try{
                var XMLRes = xhr.responseXML;
                
                if(!XMLRes || !XMLRes.documentElement){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
              
                var rootNodeName = XMLRes.documentElement.nodeName;
                if(rootNodeName == "parsereerror"){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
            }
            catch(e){
                alert("Chyba pri cteni odpovedi:"+e.toString());
            }

            vykresliMapu();
            var xmlRoot = XMLRes.documentElement;
           
            UIC = xmlRoot.getElementsByTagName("UIC");
            TRAIN_NUMBER = xmlRoot.getElementsByTagName("TRAIN_NUMBER");
            LATITUDE = xmlRoot.getElementsByTagName("LATITUDE");
            LONGITUDE = xmlRoot.getElementsByTagName("LONGITUDE");
            DATUM = xmlRoot.getElementsByTagName("DATUM");
            SPEED = xmlRoot.getElementsByTagName("SPEED");
            AZIMUT = xmlRoot.getElementsByTagName("AZIMUT");
           
                       
            naplnPole(TRAIN_NUMBER);
            
            vykresliVlaky();
            window.setInterval("vykresliVlaky()",30000);
        }else{
   
    }
    }
}

//Funkce na vykresleni mapy
function vykresliMapu(){

    var souradnice= new GLatLng(50.009075, 15.396396);
    var zoom= 7;
    map = new GMap2(document.getElementById("map"));
    map.addControl(new GSmallMapControl());
    map.addControl(new GMapTypeControl());
    map.setCenter(souradnice,zoom);
    markerCluster = new MarkerClusterer(map);
}
// funkce pro naplneni poli
function naplnPole(TRAIN_NUMBER){
   
    var PTN=TRAIN_NUMBER.item(0).firstChild.data;
    var pocet=0;
    var i=0;
                
    while(i<TRAIN_NUMBER.length){
        
        if(PTN==TRAIN_NUMBER.item(i).firstChild.data){
            pocet+=1;
        }else{
            if(pole[0]==0){
                pole[0]=pocet;
            }else{
                pole.push(pocet);
            }
            pocet=1;
            PTN=TRAIN_NUMBER.item(i).firstChild.data;
        }
        i++;
    }
    if(pocet>1){
        pole.push(pocet);
    }

    //Naplneni Dpole pro aktualni zaobrazovanej prvek

    for(var k=0; k<pole.length;k++){
        if(k==0){
            dpole[0]=0;
        }else{
            dpole.push((pole[k-1]+dpole[k-1]));
        }
    }

    for(var k=0; k<pole.length;k++){
        bpole[k]=false;
    }

}

// funkce pro vyber vlaku na vykresleni
function vykresliVlaky(){
    var markers=[];
    hodiny();
    markerCluster.clearMarkers();
    map.clearOverlays();
    var sirka,delka,dat,spe,c_vlak,point,cesta,pom;
   
    for(var j=0;j<=pole.length; j++){
        if(dpole[j]<TRAIN_NUMBER.length){
            pom=dpole[j];
            while(pole[j]>0){
                if(porovnej(dpole[j])){
                    pole[j]--;
                    dpole[j]++;
                    bpole[j]=true;
                    if(pole[j]==0){
                        bpole[j]=false;
                    }
                }else{
                    if(pom<dpole[j]){
                        dpole[j]--;
                        pole[j]++;
                    }
                    break;
                }
            }
            

            if(bpole[j]){
                sirka=LATITUDE.item(dpole[j]).firstChild.data;
                delka=LONGITUDE.item(dpole[j]).firstChild.data;
                sirka/=100000;
                delka/=100000;
               
                dat=DATUM.item(dpole[j]).firstChild.data;
                spe=SPEED.item(dpole[j]).firstChild.data;
                c_vlak=TRAIN_NUMBER.item(dpole[j]).firstChild.data;
                point = new GLatLng(sirka,delka);
                cesta=vyberikonu(dpole[j]);
                   
                markers.push(createMarker(point,dpole[j],dat,spe,c_vlak,cesta));
        
            }
        }
      }

    if(markers.length>0){
        markerCluster=new MarkerClusterer(map,markers);
    }


 
}

function createMarker(point, index,datum,speed,c_vlak,cesta) {
    // vytvoreni Ikony
    
    var ikona_vlak = new GIcon();
    ikona_vlak.image = cesta;
    
    ikona_vlak.iconSize = new GSize(70, 70);
    ikona_vlak.iconAnchor = new GPoint(35,35);
    ikona_vlak.infoWindowAnchor = new GPoint(35, 35);
    // nazev marker
    var txt="Cis. vlaku: "+c_vlak;
    var marker = new GMarker(point,{
        icon: ikona_vlak,
        title: txt
    });
    // zavreni ginfowindow
    GEvent.addListener(marker, "mouseout", function() {
        map.closeInfoWindow();
    });
    //otevreni ginfowindow
    var text="Vlak: "+c_vlak+" <br> Datum: "+datum+"<br> Rychlost: "+speed+"km/h";
    GEvent.addListener(marker, "mouseover", function() {
        marker.openInfoWindowHtml(text);
    });
    return marker;
}

// funkce pro vyber ikony
function vyberikonu(pr) {
    var azimut=AZIMUT.item(pr).firstChild.data;
    var rych=SPEED.item(pr).firstChild.data;
    var lok=UIC.item(pr).firstChild.data;
    var lok=lok.substring(5,8);
    var lokomotiva=parseInt(lok, 10);
    var sipka;
    
    if(rych==0){
        sipka="0";
    } else{
            
        if((azimut>=22)&&(azimut<67)){
            sipka="sv";
        }else{
            if((azimut>=67)&&(azimut<112)){
                sipka="v";
            }else{
                if((azimut>=112)&&(azimut<157)){
                    sipka="jv";
                }else{
                    if((azimut>=157)&&(azimut<202)){
                        sipka="j";
                    }else{
                        if((azimut>=202)&&(azimut<247)){
                            sipka="jz";
                        }else{
                            if((azimut>=247)&&(azimut<292)){
                                sipka="z";
                            }else{
                                if((azimut>=292)&&(azimut<337)){
                                    sipka="sz";
                                }else{
                                    sipka="s";
                                }
                            }
                        }
                }
        }
}
}
}
if(rych>0 && rych<50){
    sipka=sipka+"1";
}else{
    if(rych>=50 && rych<100){
        sipka=sipka+"2";
    }else{
        if(rych>=100){
            sipka=sipka+"3";
        }
    }   
}   
   
var ik="http://localhost/Finalni_Verze/PHP_Skripty/spoj.php?vlak=../Images/lokomotivy/"+lokomotiva+"&sipka=../Images/sipky/"+sipka;
return ik;
}


