// JavaScript Document
var map;
var prvek=null;
var cas=new Date(2010,2,16,12,30,0);
var MSG_ID;
var UIC;
var TRAIN_NUMBER;
var LATITUDE;
var LONGITUDE;
var DATUM;
var SPEED;
var AZIMUT;
var STATUS_MSG;
// vytvoreni Ajax aplikace
var markerCluster=null;
var xhr = vytvorXHR();
function vytvorXHR(){  
    var xhr;
    try{
        xhr = new XMLHttpRequest();
    }catch(e){
        var MSXmlVerze = new Array('MSXML2.XMLHttp.6.0','MSXML2.XMLHttp.5.0','MSXML2.XMLHttp.4.0','MSXML2.XMLHttp.3.0','MSXML2.XMLHttp.2.0','Microsoft.XMLHttp');
        for(var i = 0; i <= MSXmlVerze.length; i ++){
            try{  
                xhr = new ActiveXObject(MSXmlVerze[i]);
                alert(MSXmlVerze[i]);
                break;
            }catch(e){
             
            }
        }
    }
    if(!xhr)
        alert("Dolo k chyb pi vytven objektu XMLHttpRequest!");
    else
         
        return xhr;
}  



//funkce pro zvetseni hodin
function hodiny(){
    var d,m,n,min,sec,r;
    var loc=cas.getTime();
    loc=loc+30000;
    cas=new Date(loc);
    with(cas){
        d = getDate();
        m = getMonth()+1;
        h = getHours();
        min = getMinutes();
        sec = getSeconds();
        if (document.all)
            r = getYear()
        else r = getYear() + 1900
        }
    var text=d+"."+m+"."+r+" "+h+":"+min+":"+sec;
    document.form1.den.value=text;
}




// nacteni xml z vlaky php kteri cerpaji z databaze
function prectiSoubor(){  
    try{
        xhr.open("POST","PHP_skripty/S_mapa.php",true);
        xhr.onreadystatechange = ctiOdpoved;
        xhr.send(null);
    }catch(e){
        alert("Nelze se pipojit k serveru:\n" + e.toString());
    }
}  	

function ctiOdpoved(){
    if(xhr.readyState == 4){
        if(xhr.status == 200){
            try{
                var XMLRes = xhr.responseXML;
       
                if(!XMLRes || !XMLRes.documentElement){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
        
                var rootNodeName = XMLRes.documentElement.nodeName;
                if(rootNodeName == "parsereerror"){
                    throw("Chybn struktura XML:\n"+xhr.responseText);
                }
      
                // Vytvoreni mapy
                vytvor_mapu();

                //nacteni dat
                xmlRoot = XMLRes.documentElement;
                MSG_ID = xmlRoot.getElementsByTagName("MSG_ID");
                UIC = xmlRoot.getElementsByTagName("UIC");
                TRAIN_NUMBER = xmlRoot.getElementsByTagName("TRAIN_NUMBER");
                LATITUDE = xmlRoot.getElementsByTagName("LATITUDE");
                LONGITUDE = xmlRoot.getElementsByTagName("LONGITUDE");
                DATUM = xmlRoot.getElementsByTagName("DATUM");
                SPEED = xmlRoot.getElementsByTagName("SPEED");
                AZIMUT = xmlRoot.getElementsByTagName("AZIMUT");
                STATUS_MSG = xmlRoot.getElementsByTagName("STATUS_MSG");
                prvek=0;

                vykresli_vlaky();
                window.setInterval("vykresli_vlaky()",30000);
        
       
            }catch(e){
                alert("Chyba pri cteni odpovedi:"+e.toString());
            }
        }else{
            alert("Poadavek HTTP nen v podku")
        }
    }
}

function vytvor_mapu(){
    map = new GMap2(document.getElementById("map"));
    map.addControl(new GSmallMapControl());
    map.addControl(new GMapTypeControl());
    map.setCenter(new GLatLng(50.009075, 15.396396), 7);
    markerCluster = new MarkerClusterer(map);
}

function porovnej(pr){

    ret=/[- :]+/;
    var text=DATUM.item(pr).firstChild.data;
    d_pole=text.split(ret);
    var datum=new Date(d_pole[0],d_pole[1]-1,d_pole[2],d_pole[3],d_pole[4],d_pole[5]);

    if(datum.getTime()<cas.getTime()){
        return true;
    }
    else{
        return false;
    }
}

function vykresli_vlaky(){
    var sirka,delka,dat,spe,c_vlak,point,cesta;
    var markers=[];
    hodiny();
    markerCluster.clearMarkers();
    map.clearOverlays();
    if(prvek!=null){
        while(prvek<TRAIN_NUMBER.length && porovnej(prvek)){
            sirka=LATITUDE.item(prvek).firstChild.data;
            delka=LONGITUDE.item(prvek).firstChild.data;
            sirka/=100000;
            delka/=100000;
            dat=DATUM.item(prvek).firstChild.data;
            spe=SPEED.item(prvek).firstChild.data;
            c_vlak=TRAIN_NUMBER.item(prvek).firstChild.data;
            point = new GLatLng(sirka,delka);
            cesta=vyberikonu(prvek);
            markers.push(createMarker(point,prvek,dat,spe,c_vlak,cesta));
            prvek++;

        }
 
        if(markers.length>0){
            markerCluster=new MarkerClusterer(map,markers);
        }
    }
}


// vytvoreni ikon a vytvoreni popisku
function createMarker(point, index,datum,speed,vlak,cesta) {
    // vytvoreni Ikony
    var ikona_vlak = new GIcon();
    ikona_vlak.image = cesta;
    ikona_vlak.iconSize = new GSize(70, 70);
    ikona_vlak.iconAnchor = new GPoint(35, 35);
    ikona_vlak.infoWindowAnchor = new GPoint(35, 35);
   
    var txt="Cis. vlaku: "+vlak;
    var marker = new GMarker(point, {
        icon: ikona_vlak,
        title: txt
    });

    GEvent.addListener(marker, "mouseout", function() {
        map.closeInfoWindow();
    });
  
    var text="Vlak: <br> Datum: "+datum+"<br> Rychlost: "+speed+" km/h <br> Vlak: "+vlak;
    GEvent.addListener(marker, "mouseover", function() {
        marker.openInfoWindowHtml(text);
    });
    return marker;
}


 
function vyberikonu(pr) {

    var azimut=AZIMUT.item(pr).firstChild.data;
    var rych=SPEED.item(pr).firstChild.data;

    var lok=UIC.item(pr).firstChild.data;
    var lok=lok.substring(5,8);
    var lokomotiva=parseInt(lok, 10);
    var sipka;
    
    if(rych==0){
        sipka="0";
    } else{
            
        if((azimut>=22)&&(azimut<67)){
            sipka="sv";
        }else{
            if((azimut>=67)&&(azimut<112)){
                sipka="v";
            }else{
                if((azimut>=112)&&(azimut<157)){
                    sipka="jv";
                }else{
                    if((azimut>=157)&&(azimut<202)){
                        sipka="j";
                    }else{
                        if((azimut>=202)&&(azimut<247)){
                            sipka="jz";
                        }else{
                            if((azimut>=247)&&(azimut<292)){
                                sipka="z";
                            }else{
                                if((azimut>=292)&&(azimut<337)){
                                    sipka="sz";
                                }else{
                                    sipka="s";
                                }
                            }
                        }
                }
        }
}
}
}
if(rych>0 && rych<50){
    sipka=sipka+"1";
}else{
    if(rych>=50 && rych<100){
        sipka=sipka+"2";
    }else{
        if(rych>=100){
            sipka=sipka+"3";
        }
    }   
}   
   
var ik="http://localhost/Finalni_Verze/PHP_Skripty/spoj.php?vlak=../Images/lokomotivy/"+lokomotiva+"&sipka=../Images/sipky/"+sipka;
return ik;
}